using static System.Console;
using static System.Math;

// The game of 21 (playable)

class TwentyOne {
  static int maxValue(int state, out int best) {
    best = 0;
    
    if (state >= 21)
      return 1;   // I won
      
    int val = int.MinValue;
    for (int i = 1 ; i <= 3 ; ++i) {
      int v = minValue(state + i, out int dummy);
      if (v > val) {
        val = v;
        best = i;
      }
    }
      
    return val;
  }

  static int minValue(int state, out int best) {
    best = 0;
    
    if (state >= 21)
      return -1;  // I won
    
    int val = int.MaxValue;
    for (int i = 1 ; i <= 3 ; ++i) {
      int v = maxValue(state + i, out int dummy);
      if (v < val) {
        val = v;
        best = i;
      }
    }
      
    return val;
  }
  
  static void Main() {
    WriteLine("Human, are you player 1 or 2?");
    int human = int.Parse(ReadLine());
    int n = 0;
    int turn = 1;  // player 1 goes first
    while (n < 21) {
      int move;
      if (turn == human) {
        while (true) {
          Write("Your move? ");
          move = int.Parse(ReadLine());
          if (1 <= move && move <= 3)
            break;
          WriteLine("Illegal!  Move must be between 1 and 3");
        }
      } else { // computer move
          if (turn == 1)
            maxValue(n, out move);
          else minValue(n, out move);
          WriteLine("I play " + move);
        }
      n += move;
      WriteLine("The total is now " + n + "\n");
      turn = 3 - turn;
    }
    WriteLine((turn == human ? "Human" : "Computer") + " wins");
  }
}
